Summary: the independent LEGO Mindstorms OS
Name: legOS
Version: 0.2.3
Release: 1
Copyright: MPL 1.0
Group: Development/Mindstorms
Url: http://www.noga.de/legOS/
Packager: James Henstridge <james@daa.com.au>

Source: http://www.noga.de/legOS/legOS-%{version}.tar.gz
Patch0: legOS-makefile.patch

Requires: rcx-egcs, rcx-binutils

BuildRoot: /var/tmp/%{name}-root

%description
legOS is an open-source embedded operating system for the LEGO Mindstorms,
a LEGO brick with a brain. Compared to the standard software, it offers
vastly superior performance and flexibility.

%prep
%setup -n legOS
%patch0 -p1

# remove some of the crud distributed with legOS.
rm util/{dll,makelx,firmdl3,fontdesign}
rm lib/*.a
ln -s ../../boot/config.h lib/c++

%build
make depend
make
make -C lib/c++

# HTML documentation -- requires doxygen to be installed.
make html

%clean
rm -rf ${RPM_BUILD_ROOT}

%install
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/boot
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/demo
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/include
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/include/c++
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/include/rom
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/include/sys
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/lib
install -d ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/util

# modify LEGOS_ROOT now that we are installing 
sed 's,^LEGOS_ROOT=.*$,LEGOS_ROOT=%{_prefix}/lib/legOS/,' \
  < Makefile.common > ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/Makefile.common
install -m 664 Makefile.user ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS

install -m 664 boot/config.h    ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/boot
install -m 664 boot/legOS.dis2  ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/boot
install -m 664 boot/legOS.lds   ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/boot
install -m 664 boot/legOS.srec  ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/boot

# Demos
ln -sf ../boot/config.h ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/demo
install -m 664 demo/Makefile      ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/demo
for file in demo/*.c demo/*.lx; do
  install -m 664 $file ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/demo
done

# Headers
for file in include/*.h; do
  install -m 664 $file ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/include
done
for file in include/c++/*.h; do
  install -m 664 $file ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/include/c++
done
for file in include/rom/*.h; do
  install -m 664 $file ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/include/rom
done
for file in include/sys/*.h; do
  install -m 664 $file ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/include/sys
done

# Libraries
for file in lib/*.a; do
  install -m 664 $file ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/lib
done

# Utilities
for file in util/{dll,firmdl3,fontdesign,genlds,makelx,merge-map,fixdeps}; do
  install -m 775 $file ${RPM_BUILD_ROOT}%{_prefix}/lib/legOS/util
done


%files
%defattr(-,root,root)
%{_prefix}/lib/legOS/Makefile.common
%{_prefix}/lib/legOS/Makefile.user
%{_prefix}/lib/legOS/boot/*
%{_prefix}/lib/legOS/demo/*
%{_prefix}/lib/legOS/include/*.h
%{_prefix}/lib/legOS/include/c++/*.h
%{_prefix}/lib/legOS/include/rom/*.h
%{_prefix}/lib/legOS/include/sys/*.h
%{_prefix}/lib/legOS/lib/*
%{_prefix}/lib/legOS/util/*

%doc CONTRIBUTORS LICENSE NEWS README TODO VERSION
%doc doc/Notes_on_intterupts doc/Pros_and_Cons doc/Sensors
%doc doc/html

